function XMLDataReader() {
	var self = this; self.name = "XMLDataReader"; // MANDATORY

	this.xml = null;
	this.ready = false;
	this.timestamp = "";
    
    this.loadURL = function(url,timestamp){
        if(typeof(timestamp) !== "undefined"){this.timestamp = timestamp;}
        var xhr = new XMLHttpRequest();
        url = url+"?"+Date.now();
        xhr.open("GET", url, true);
        xhr.setRequestHeader("Content-Type", "text/xml");
        xhr.addEventListener("load", function () {
            if (xhr.status === 200 
								|| (xhr.status === 0 && self.platform == "ONLINE")
								|| (xhr.status === 0 && self.platform == "WEB")
                || (xhr.status === 0 && self.platform == "WEBOS")
                || (xhr.status === 0 && self.platform == "MAC")
                || (xhr.status === 0 && self.platform == "LINUX")
                || (xhr.status === 0 && self.platform == "TIZEN")
                || (xhr.status === 0 && self.platform == "WIN")
                || (xhr.status === 0 && self.platform == "ANDROID")
                || (xhr.status === 0 && self.platform == "IOS")) {
                self.loadXML(xhr.response);
            }else{
                self.log("Loaded Error : "+url+" status : "+xhr.status);
                self.log(xhr.response);
            }
        }, false);
        xhr.addEventListener("error", function (e) {
            self.log("XML Loading Error for: "+url);
						self.notifyError(self.ERROR['XML_DATA_READER']+1,self.name+": XMLDataReaderDataError: An error occurred loading XML Data from : "+url);
            $(self).trigger("XMLDataReaderDataError");
        }, false);
        xhr.send();
    }

	this.loadXML = function(data) {
		try{
			var xml = $($.parseXML(data));
			var timestamp = xml.find("*").eq(0).attr('timestamp');
	        self.log(timestamp+" : "+this.timestamp);
			if (timestamp != this.timestamp && timestamp != "" && typeof (timestamp) != "undefined") {
				this.timestamp = timestamp;
				this.xml = null;
				this.xml = $($.parseXML(data));
	      self.log("XML New Data is Loaded");
				this.ready = true;
			}else{
        self.log("XML NOTHING NEW IN XML DATA !");
        }
			xml = null;
			$(self).trigger("XMLDataReaderDataLoaded");
		}catch(e){
			self.notifyError(self.ERROR['XML_DATA_READER']+2,self.name+": XMLDataReaderDataError: Error parsing XML Data");
			$(self).trigger("XMLDataReaderDataError");
		}
	};
    
	this.template = function(id) {
		if (this.xml != null) {
			var query = self.execute(function() {
				return self.xml.find("archive").find("template[id='" + id + "']");
			});
			if (query && query.length > 0) {
				return query;
			} else {
				return false;
			}
		} else {
			return false;
		}
	};

	this.archive = function(id) {
		if (this.xml != null) {
			var query = self.execute(function() {
				return self.xml.find("archive");
			});

			if (query && query.length > 0) {
				return query;
			} else {
				return false;
			}
		} else {
			return false;
		}
	};
    
    this.file = function(id) {
		if (this.xml != null) {
			var query = self.execute(function() {
				return self.xml.find("archive").find("files[id='" + id + "']");
			});

			if (query && query.length > 0) {
				return query;
			} else {
				return false;
			}
		} else {
			return false;
		}
	};

	this.condition_types = function() {
		if (this.xml != null) {
			var query = self.execute(function() {
				return self.xml.find("condition_types");
			});

			if (query && query.length > 0) {
				return query;
			} else {
				return false;
			}
		} else {
			return false;
		}
	};

	this.condition_trigger = function() {
		if (this.xml != null) {
			var query = self.execute(function() {
				return self.xml.find("condition_trigger");
			});

			if (query && query.length > 0) {
				return query;
			} else {
				return false;
			}
		} else {
			return false;
		}
	};

	this.loops = function() {
		if (this.xml != null) {
			var query = self.execute(function() {
                return self.xml.find("loop");
			});

			if (query && query.length > 0) {
				return query;
			} else {
				return false;
			}
		} else {
			return false;
		}
	};

	this.block = function(id) {
		if (this.xml != null) {
			var query = self.execute(function() {
				return self.xml.find("playlist").find(":first-child").find("blocks[id='" + id + "']");
			});

			if (query && query.length > 0) {
				return query;
			} else {
				return false;
			}
		} else {
			return false;
		}
	};

	this.timeline = function() {
		if (this.xml != null) {
			var query = self.execute(function() {
				return self.xml.find("timeline");
			});

			if (query && query.length > 0) {
				return query;
			} else {
				return false;
			}
		} else {
			return false;
		}
	};

	this.configuration = function() {
		if (this.xml != null) {
			var query = self.execute(function() {
				return self.xml.find("config");
			});

			if (query && query.length > 0) {
				return query;
			} else {
				return false;
			}
		} else {
			return false;
		}
	};

	this.stats = function() {
		if (this.xml != null) {
			var query = self.execute(function() {
				return self.xml.find("stats");
			});

			if (query && query.length > 0) {
				return query;
			} else {
				return false;
			}
		} else {
			return false;
		}
	};
	
	this.screens = function() {
		if (this.xml != null) {
			var query = self.execute(function() {
				return self.xml.find("screens");
			});

			if (query && query.length > 0) {
				return query;
			} else {
				return false;
			}
		} else {
			return false;
		}
	};

	this.screenExceptions = function() {
		if (this.xml != null) {
			var query = self.execute(function() {
				return self.xml.find("screen_exceptions");
			});

			if (query && query.length > 0) {
				return query;
			} else {
				return false;
			}
		} else {
			return false;
		}
	};
}
XMLDataReader.prototype = new SystemController();
